diff --git a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index 3be1a3e85..5867617a9 100644
--- a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -3,92 +3,90 @@ package net.minecraft.client.render;
 import java.util.HashMap;
 import java.util.Map;
 
+import net.minecraft.client.render.model.BipedModel;
+import net.minecraft.client.render.model.ChickenModel;
+import net.minecraft.client.render.model.CowModel;
+import net.minecraft.client.render.model.SheepModel;
+import net.minecraft.client.render.model.SkeletonModel;
+import net.minecraft.client.render.model.SquidModel;
+import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.entity.animal.SquidMob;
+import net.minecraft.core.entity.monster.CreeperMob;
+import net.minecraft.core.entity.monster.SkeletonMob;
+import net.minecraft.core.entity.monster.SlimeMob;
+import net.minecraft.core.entity.monster.ZombieArmoredMob;
+import net.minecraft.core.entity.projectile.CannonballProjectile;
+import net.minecraft.core.entity.projectile.EggProjectile;
+import net.minecraft.core.entity.projectile.SnowballProjectile;
+import net.minecraft.core.entity.vehicle.BoatEntity;
+import net.minecraft.core.item.Items;
 import org.lwjgl.opengl.GL11;
-
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.entity.ArmoredZombieRenderer;
 import net.minecraft.client.render.entity.ArrowRenderer;
 import net.minecraft.client.render.entity.BoatRenderer;
-import net.minecraft.client.render.entity.BobberRenderer;
+import net.minecraft.client.render.entity.FishingBobberRenderer;
 import net.minecraft.client.render.entity.CannonballRenderer;
 import net.minecraft.client.render.entity.ChickenRenderer;
 import net.minecraft.client.render.entity.CowRenderer;
 import net.minecraft.client.render.entity.CreeperRenderer;
 import net.minecraft.client.render.entity.DefaultRenderer;
 import net.minecraft.client.render.entity.EntityRenderer;
-import net.minecraft.client.render.entity.FallingSandRenderer;
-import net.minecraft.client.render.entity.FireballRenderer;
+import net.minecraft.client.render.entity.FallingBlockRenderer;
 import net.minecraft.client.render.entity.FireflyRenderer;
 import net.minecraft.client.render.entity.GhastRenderer;
 import net.minecraft.client.render.entity.GiantRenderer;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
 import net.minecraft.client.render.entity.LightningBoltRenderer;
-import net.minecraft.client.render.entity.LivingRenderer;
-import net.minecraft.client.render.entity.MinecartRenderer;
 import net.minecraft.client.render.entity.MobRenderer;
-import net.minecraft.client.render.entity.MonsterRenderer;
+import net.minecraft.client.render.entity.MinecartRenderer;
+import net.minecraft.client.render.entity.BipedRenderer;
+import net.minecraft.client.render.entity.HumanRenderer;
 import net.minecraft.client.render.entity.PaintingRenderer;
 import net.minecraft.client.render.entity.PigRenderer;
 import net.minecraft.client.render.entity.PlayerRenderer;
 import net.minecraft.client.render.entity.ScorpionRenderer;
 import net.minecraft.client.render.entity.SheepRenderer;
 import net.minecraft.client.render.entity.SlimeRenderer;
-import net.minecraft.client.render.entity.SnowballRenderer;
+import net.minecraft.client.render.entity.SpriteRenderer;
 import net.minecraft.client.render.entity.SpiderRenderer;
 import net.minecraft.client.render.entity.SquidRenderer;
 import net.minecraft.client.render.entity.TNTRenderer;
 import net.minecraft.client.render.entity.WolfRenderer;
-import net.minecraft.client.render.model.ModelBiped;
-import net.minecraft.client.render.model.ModelChicken;
-import net.minecraft.client.render.model.ModelCow;
-import net.minecraft.client.render.model.ModelPig;
-import net.minecraft.client.render.model.ModelSheep;
-import net.minecraft.client.render.model.ModelSheepOverlay;
-import net.minecraft.client.render.model.ModelSheepWool;
-import net.minecraft.client.render.model.ModelSkeleton;
-import net.minecraft.client.render.model.ModelSlime;
-import net.minecraft.client.render.model.ModelSquid;
-import net.minecraft.client.render.model.ModelWolf;
-import net.minecraft.client.render.model.ModelZombie;
+import net.minecraft.client.render.model.PigModel;
+import net.minecraft.client.render.model.SheepOverlayModel;
+import net.minecraft.client.render.model.SheepWoolModel;
+import net.minecraft.client.render.model.SlimeModel;
+import net.minecraft.client.render.model.WolfModel;
+import net.minecraft.client.render.model.ZombieModel;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityBobber;
-import net.minecraft.core.entity.EntityFallingSand;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLightningBolt;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.EntityPainting;
-import net.minecraft.core.entity.EntityTNT;
-import net.minecraft.core.entity.animal.EntityChicken;
-import net.minecraft.core.entity.animal.EntityCow;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.entity.animal.EntityPig;
-import net.minecraft.core.entity.animal.EntitySheep;
-import net.minecraft.core.entity.animal.EntitySquid;
-import net.minecraft.core.entity.animal.EntityWolf;
-import net.minecraft.core.entity.monster.EntityArmoredZombie;
-import net.minecraft.core.entity.monster.EntityCreeper;
-import net.minecraft.core.entity.monster.EntityGhast;
-import net.minecraft.core.entity.monster.EntityGiant;
-import net.minecraft.core.entity.monster.EntityHuman;
-import net.minecraft.core.entity.monster.EntityScorpion;
-import net.minecraft.core.entity.monster.EntitySkeleton;
-import net.minecraft.core.entity.monster.EntitySlime;
-import net.minecraft.core.entity.monster.EntitySnowman;
-import net.minecraft.core.entity.monster.EntitySpider;
-import net.minecraft.core.entity.monster.EntityZombie;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityCannonball;
-import net.minecraft.core.entity.projectile.EntityEgg;
-import net.minecraft.core.entity.projectile.EntityFireball;
-import net.minecraft.core.entity.projectile.EntityPebble;
-import net.minecraft.core.entity.projectile.EntitySnowball;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.FishingBobberEntity;
+import net.minecraft.core.entity.FallingBlockEntity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.PaintingEntity;
+import net.minecraft.core.entity.TNTPrimedEntity;
+import net.minecraft.core.entity.animal.ChickenMob;
+import net.minecraft.core.entity.animal.CowMob;
+import net.minecraft.core.entity.animal.PigMob;
+import net.minecraft.core.entity.animal.SheepMob;
+import net.minecraft.core.entity.animal.WolfMob;
+import net.minecraft.core.entity.monster.GhastMob;
+import net.minecraft.core.entity.monster.GiantMob;
+import net.minecraft.core.entity.monster.HumanMob;
+import net.minecraft.core.entity.monster.ScorpionMob;
+import net.minecraft.core.entity.monster.SnowmanMob;
+import net.minecraft.core.entity.monster.SpiderMob;
+import net.minecraft.core.entity.monster.ZombieMob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
+import net.minecraft.core.entity.projectile.FireballProjectile;
+import net.minecraft.core.entity.projectile.PebbleProjectile;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.world.World;
 
 public class EntityRenderDispatcher
@@ -96,45 +94,46 @@ public class EntityRenderDispatcher
     private EntityRenderDispatcher()
     {
         renderers = new HashMap<>();
-        renderers.put(EntitySpider.class, new SpiderRenderer());
-        renderers.put(EntityScorpion.class, new ScorpionRenderer());
-        renderers.put(EntityPig.class, new PigRenderer(new ModelPig(), new ModelPig(0.5F), 0.7F));
-        renderers.put(EntitySheep.class, new SheepRenderer(new ModelSheep(), new ModelSheepWool(), new ModelSheepOverlay(), 0.7F));
-        renderers.put(EntityCow.class, new CowRenderer(new ModelCow(), 0.7F));
-        renderers.put(EntityWolf.class, new WolfRenderer(new ModelWolf(0.0f), 0.5F));
-        renderers.put(EntityChicken.class, new ChickenRenderer(new ModelChicken(), 0.3F));
-        renderers.put(EntityCreeper.class, new CreeperRenderer());
-        renderers.put(EntitySkeleton.class, new MobRenderer<>(new ModelSkeleton(), 0.5F));
-        renderers.put(EntityZombie.class, new MobRenderer<>(new ModelZombie(), 0.5F));
-        renderers.put(EntitySnowman.class, new MobRenderer<>(new ModelZombie(), 0.5F));
-        renderers.put(EntityArmoredZombie.class, new ArmoredZombieRenderer(new ModelZombie(), 0.5F));
-        renderers.put(EntitySlime.class, new SlimeRenderer(new ModelSlime(16), new ModelSlime(0), 0.25F));
-        renderers.put(EntityPlayer.class, new PlayerRenderer());
-        renderers.put(EntityHuman.class, new MonsterRenderer());
-        renderers.put(EntityGiant.class, new GiantRenderer(new ModelZombie(), 0.5F, 6F));
-        renderers.put(EntityGhast.class, new GhastRenderer());
-        renderers.put(EntitySquid.class, new SquidRenderer(new ModelSquid(), 0.7F));
-        renderers.put(EntityLiving.class, new LivingRenderer<>(new ModelBiped(), 0.5F));
+        renderers.put(SpiderMob.class, new SpiderRenderer());
+        renderers.put(ScorpionMob.class, new ScorpionRenderer());
+        renderers.put(PigMob.class, new PigRenderer(new PigModel(), new PigModel(0.5F), 0.7F));
+        renderers.put(SheepMob.class, new SheepRenderer(new SheepModel(), new SheepWoolModel(), new SheepOverlayModel(), 0.7F));
+        renderers.put(CowMob.class, new CowRenderer(new CowModel(), 0.7F));
+        renderers.put(WolfMob.class, new WolfRenderer(new WolfModel(0.0f), 0.5F));
+        renderers.put(ChickenMob.class, new ChickenRenderer(new ChickenModel(), 0.3F));
+        renderers.put(CreeperMob.class, new CreeperRenderer());
+        renderers.put(SkeletonMob.class, new BipedRenderer<>(new SkeletonModel(), 0.5F));
+        renderers.put(ZombieMob.class, new BipedRenderer<>(new ZombieModel(), 0.5F));
+        renderers.put(SnowmanMob.class, new BipedRenderer<>(new ZombieModel(), 0.5F));
+        renderers.put(ZombieArmoredMob.class, new ArmoredZombieRenderer(new ZombieModel(), 0.5F));
+        renderers.put(SlimeMob.class, new SlimeRenderer(new SlimeModel(16), new SlimeModel(0), 0.25F));
+        renderers.put(Player.class, new PlayerRenderer());
+        renderers.put(HumanMob.class, new HumanRenderer());
+        renderers.put(GiantMob.class, new GiantRenderer(new ZombieModel(), 0.5F, 6F));
+        renderers.put(GhastMob.class, new GhastRenderer());
+        renderers.put(SquidMob.class, new SquidRenderer(new SquidModel(), 0.7F));
+        renderers.put(Mob.class, new MobRenderer<>(new BipedModel(), 0.5F));
         renderers.put(Entity.class, new DefaultRenderer());
-        renderers.put(EntityPainting.class, new PaintingRenderer());
-        renderers.put(EntityArrow.class, new ArrowRenderer());
-        renderers.put(EntitySnowball.class, new SnowballRenderer(Item.ammoSnowball));
-        renderers.put(EntityEgg.class, new SnowballRenderer(Item.eggChicken));
-        renderers.put(EntityFireball.class, new FireballRenderer());
-        renderers.put(EntityItem.class, new ItemEntityRenderer());
-        renderers.put(EntityTNT.class, new TNTRenderer());
-        renderers.put(EntityFallingSand.class, new FallingSandRenderer());
-        renderers.put(EntityMinecart.class, new MinecartRenderer());
-        renderers.put(EntityBoat.class, new BoatRenderer());
-        renderers.put(EntityBobber.class, new BobberRenderer());
-        renderers.put(EntityFireflyCluster.class, new FireflyRenderer());
-        renderers.put(EntityLightningBolt.class, new LightningBoltRenderer());
-        renderers.put(EntityCannonball.class, new CannonballRenderer());
-        renderers.put(EntityPebble.class, new SnowballRenderer(Item.ammoPebble));
+        renderers.put(PaintingEntity.class, new PaintingRenderer());
+        renderers.put(ArrowProjectile.class, new ArrowRenderer());
+        renderers.put(SnowballProjectile.class, new SpriteRenderer<SnowballProjectile>(Items.AMMO_SNOWBALL));
+        renderers.put(EggProjectile.class, new SpriteRenderer<EggProjectile>(Items.EGG_CHICKEN));
+        renderers.put(FireballProjectile.class, new SpriteRenderer<FireballProjectile>(Items.AMMO_FIREBALL).setScale(4).setFullBright());
+        renderers.put(ItemEntity.class, new ItemEntityRenderer());
+        renderers.put(TNTPrimedEntity.class, new TNTRenderer());
+        renderers.put(FallingBlockEntity.class, new FallingBlockRenderer());
+        renderers.put(MinecartEntity.class, new MinecartRenderer());
+        renderers.put(BoatEntity.class, new BoatRenderer());
+        renderers.put(FishingBobberEntity.class, new FishingBobberRenderer());
+        renderers.put(FireflyClusterMob.class, new FireflyRenderer());
+        renderers.put(LightningEntity.class, new LightningBoltRenderer());
+        renderers.put(CannonballProjectile.class, new CannonballRenderer());
+        renderers.put(PebbleProjectile.class, new SpriteRenderer<PebbleProjectile>(Items.AMMO_PEBBLE));
+
 
         for (EntityRenderer<?> renderer : renderers.values())
         {
-            renderer.setRenderDispatcher(this);
+            renderer.init(this);
         }
     }
 
@@ -198,8 +197,8 @@ public class EntityRenderDispatcher
         EntityRenderer<T> renderer = getRenderer(entity);
         if(renderer != null)
         {
-            renderer.doRender(tessellator, entity, x, y, z, yaw, partialTick);
-            renderer.doRenderShadowAndFire(tessellator, entity, x, y, z, yaw, partialTick);
+            renderer.render(tessellator, entity, x, y, z, yaw, partialTick);
+            renderer.postRender(tessellator, entity, x, y, z, yaw, partialTick);
         }
     }
 
@@ -208,7 +207,7 @@ public class EntityRenderDispatcher
         EntityRenderer<T> renderer = getRenderer(entity);
         if(renderer != null)
         {
-            renderer.doRenderPreview(tessellator, entity, x, y, z, yaw, partialTick);
+            renderer.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/FlagRenderer.java b/src/main/java/net/minecraft/client/render/FlagRenderer.java
index af9714c1b..c4b09a2c3 100644
--- a/src/main/java/net/minecraft/client/render/FlagRenderer.java
+++ b/src/main/java/net/minecraft/client/render/FlagRenderer.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.GLAllocation;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.util.helper.Colors;
@@ -28,7 +28,7 @@ public class FlagRenderer {
         GLAllocation.deleteTexture(texture);
     }
 
-    public void updateTexture(TileEntityFlag tileEntity)
+    public void updateTexture(FlagBlockEntity tileEntity)
     {
         byte[] flagColors = tileEntity.flagColors;
         int[] rgbFlagColors = flagDataToRGB(tileEntity, flagColors);
@@ -40,7 +40,7 @@ public class FlagRenderer {
         return texture;
     }
 
-    private int[] flagDataToRGB(TileEntityFlag tileEntity, byte[] colorData)
+    private int[] flagDataToRGB(FlagBlockEntity tileEntity, byte[] colorData)
     {
         int[] data = new int[CANVAS_WIDTH * CANVAS_HEIGHT];
 
@@ -61,13 +61,13 @@ public class FlagRenderer {
         return data;
     }
 
-    private int getColorMap(TileEntityFlag tileEntity, int index)
+    private int getColorMap(FlagBlockEntity tileEntity, int index)
     {
         int col = 0x00FFFFFF;
         if(index > 0 && index <= 3)
         {
-            ItemStack stack = tileEntity.getStackInSlot(35 + index);
-            if (stack != null && stack.getItem() == Item.dye)
+            ItemStack stack = tileEntity.getItem(35 + index);
+            if (stack != null && stack.getItem() == Items.DYE)
             {
                 col = Colors.allFlagColors[TextFormatting.get(15 - stack.getMetadata()).id].getARGB();
             }
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index 3e46d7808..1a0c9d8fe 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -4,6 +4,7 @@ import static org.lwjgl.opengl.GL11.*;
 
 import java.nio.FloatBuffer;
 
+import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.opengl.NVFogDistance;
 
 import net.minecraft.client.GLAllocation;
@@ -15,7 +16,6 @@ import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 
@@ -44,7 +44,7 @@ public class FogManager {
         float fogModifier = mc.theWorld.getCurrentWeather() != null ? mc.theWorld.getCurrentWeather().fogDistance : 1.0f;
         fogModifier = (1.0f - ((1.0f - fogModifier) * mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower()));
 
-        float brightnessAtCamera = mc.theWorld.getLightBrightness(MathHelper.floor_double(mc.activeCamera.getX(1f)), MathHelper.floor_double(mc.activeCamera.getY(1f)), MathHelper.floor_double(mc.activeCamera.getZ(1f)));
+        float brightnessAtCamera = mc.theWorld.getLightBrightness(MathHelper.floor(mc.activeCamera.getX(1f)), MathHelper.floor(mc.activeCamera.getY(1f)), MathHelper.floor(mc.activeCamera.getZ(1f)));
         if (mc.fullbright) brightnessAtCamera = 1.0f;
         float renderDistanceModifier = ((3 - mc.gameSettings.renderDistance.value.legacyValue) * fogModifier) / 3F;
         float newBrightness = brightnessAtCamera * (1.0F - renderDistanceModifier) + renderDistanceModifier;
@@ -54,7 +54,7 @@ public class FogManager {
 
     public void setupFog(int fogMode, float farPlaneDistance, float partialTick)
     {
-        glFog(GL_FOG_COLOR, buffer(fogRed, fogGreen, fogBlue, 0.5F));
+        glFogfv(GL_FOG_COLOR, buffer(fogRed, fogGreen, fogBlue, 0.5F));
         glNormal3f(0.0F, -1F, 0.0F);
         glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.theWorld, Material.water, partialTick))
@@ -111,15 +111,15 @@ public class FogManager {
         float renderDistanceScale = 1.0F / (float)(4 - mc.gameSettings.renderDistance.value.legacyValue);
         renderDistanceScale = 1.0F - (float) Math.pow(renderDistanceScale, 0.25D);
 
-        Vec3d skyColor = world.getSkyColor(mc.activeCamera, partialTick);
-        float rSky = (float)skyColor.xCoord;
-        float gSky = (float)skyColor.yCoord;
-        float bSky = (float)skyColor.zCoord;
+        Vec3 skyColor = world.getSkyColor(mc.activeCamera, partialTick);
+        float rSky = (float)skyColor.x;
+        float gSky = (float)skyColor.y;
+        float bSky = (float)skyColor.z;
 
-        Vec3d worldColor = world.getFogColor(mc.activeCamera, partialTick);
-        fogRed = (float)worldColor.xCoord;
-        fogGreen = (float)worldColor.yCoord;
-        fogBlue = (float)worldColor.zCoord;
+        Vec3 worldColor = world.getFogColor(mc.activeCamera, partialTick);
+        fogRed = (float)worldColor.x;
+        fogGreen = (float)worldColor.y;
+        fogBlue = (float)worldColor.z;
 
         fogRed += (rSky - fogRed) * renderDistanceScale;
         fogGreen += (gSky - fogGreen) * renderDistanceScale;
@@ -139,8 +139,8 @@ public class FogManager {
             fogBlue = 0.2F;
             if(mc.gameSettings.biomeWater.value)
             {
-                int x = MathHelper.floor_double(mc.activeCamera.getX(partialTick));
-                int z = MathHelper.floor_double(mc.activeCamera.getZ(partialTick));
+                int x = MathHelper.floor(mc.activeCamera.getX(partialTick));
+                int z = MathHelper.floor(mc.activeCamera.getZ(partialTick));
                 double temp = world.getBlockTemperature(x, z);
                 double humid = world.getBlockHumidity(x, z);
                 int waterColor = Colorizers.water.getColor(temp, humid);
diff --git a/src/main/java/net/minecraft/client/render/FontRenderer.java b/src/main/java/net/minecraft/client/render/FontRenderer.java
index 539b6d640..e1b89fbf9 100644
--- a/src/main/java/net/minecraft/client/render/FontRenderer.java
+++ b/src/main/java/net/minecraft/client/render/FontRenderer.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.lang.text.Text;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.Texture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.Color;
@@ -16,7 +17,6 @@ import java.io.IOException;
 import java.io.InputStream;
 import java.text.Bidi;
 import java.util.Arrays;
-import java.util.Iterator;
 import java.util.List;
 import java.util.Random;
 import java.util.regex.Pattern;
@@ -120,19 +120,15 @@ public class FontRenderer {
         String fontPath = String.format("/font/font_%02X.png", id);
         String glyphPath = String.format("/font/glyph_%02X.png", id);
 
-        BufferedImage fontTexture;
-        try {
-            fontTexture = ImageIO.read(mc.texturePackList.getResourceAsStream(fontPath));
-        } catch (IOException | IllegalArgumentException e) {
-            success = false;
-            try {
-                fontTexture = ImageIO.read(mc.texturePackList.getResourceAsStream(glyphPath));
-            } catch (IOException e1) {
-                throw new RuntimeException(e1);
-            }
+        Texture fontTexture = this.renderEngine.loadTextureNoDefault(fontPath);
+        if (fontTexture == null) {
+            fontTexture = this.renderEngine.loadTextureNoDefault(glyphPath);
+        }
+        if (fontTexture == null) {
+            throw new RuntimeException("Failed to load texture from '" + fontPath + "' or '" + glyphPath + "'!");
         }
 
-        this.fontTextureNames[id] = this.renderEngine.allocateAndSetupTexture(fontTexture);
+        this.fontTextureNames[id] = fontTexture.id();
         this.boundTextureName = this.fontTextureNames[id];
         return success;
     }
@@ -191,7 +187,7 @@ public class FontRenderer {
             throw new RuntimeException(var5);
         }
 
-        this.glyphTextureNames[id] = this.renderEngine.allocateAndSetupTexture(glyphTexture);
+        this.glyphTextureNames[id] = this.renderEngine.loadBufferedTexture(glyphTexture).id();
         this.boundTextureName = this.glyphTextureNames[id];
     }
 
@@ -502,14 +498,14 @@ public class FontRenderer {
 
     }
 
-    private int renderStringAligned(String par1Str, int par2, int par3, int par4, int par5, boolean par6) {
+    private int renderStringAligned(String s, int x, int y, int maxWidth, int argb, boolean isShadow) {
         if(this.bidiFlag) {
-            par1Str = this.bidiReorder(par1Str);
-            int var7 = this.getStringWidth(par1Str);
-            par2 = par2 + par4 - var7;
+            s = this.bidiReorder(s);
+            int width = this.getStringWidth(s);
+            x = x + maxWidth - width;
         }
 
-        return this.renderStringInternal(par1Str, par2, par3, par5, par6);
+        return this.renderStringInternal(s, x, y, argb, isShadow);
     }
 
     public void renderString(String par1Str, int par2, int par3, int par4, boolean par5) {
@@ -613,20 +609,20 @@ public class FontRenderer {
         }
     }
 
-    public String trimStringToWidth(String par1Str, int par2) {
-        return this.trimStringToWidth(par1Str, par2, false);
+    public String trimStringToWidth(String s, int maxWidth) {
+        return this.trimStringToWidth(s, maxWidth, false);
     }
 
-    public String trimStringToWidth(String par1Str, int par2, boolean par3) {
+    public String trimStringToWidth(String s, int maxWidth, boolean par3) {
         StringBuilder var4 = new StringBuilder();
         int var5 = 0;
-        int var6 = par3 ? par1Str.length() - 1 : 0;
+        int var6 = par3 ? s.length() - 1 : 0;
         int var7 = par3 ? -1 : 1;
         boolean var8 = false;
         boolean var9 = false;
 
-        for(int var10 = var6; var10 >= 0 && var10 < par1Str.length() && var5 < par2; var10 += var7) {
-            char var11 = par1Str.charAt(var10);
+        for(int var10 = var6; var10 >= 0 && var10 < s.length() && var5 < maxWidth; var10 += var7) {
+            char var11 = s.charAt(var10);
             int var12 = this.getCharWidth(var11);
             if(var8) {
                 var8 = false;
@@ -646,7 +642,7 @@ public class FontRenderer {
                 }
             }
 
-            if(var5 > par2) {
+            if(var5 > maxWidth) {
                 break;
             }
 
@@ -660,50 +656,50 @@ public class FontRenderer {
         return var4.toString();
     }
 
-    private String trimStringNewline(String par1Str) {
-        while(par1Str != null && par1Str.endsWith("\n")) {
-            par1Str = par1Str.substring(0, par1Str.length() - 1);
+    private String trimStringNewline(String s) {
+        while(s != null && s.endsWith("\n")) {
+            s = s.substring(0, s.length() - 1);
         }
 
-        return par1Str;
+        return s;
     }
 
-    public void func_27278_a(String par1Str, int par2, int par3, int par4, int par5) {
-        this.func_40609_a(par1Str, par2, par3, par4, par5, false);
+    public void drawStringIntoConstrainedBlock(String s, int x, int y, int maxWidth, int argb) {
+        this.drawStringIntoConstrainedBlock(s, x, y, maxWidth, argb, false);
     }
 
-    private void renderSplitString(String par1Str, int par2, int par3, int par4, boolean par5) {
-        List var6 = this.listFormattedStringToWidth(par1Str, par4);
+    private void renderSplitString(String s, int x, int y, int maxWidth, boolean isShadow) {
+        List<String> lines = this.listFormattedStringToWidth(s, maxWidth);
 
-        for(Iterator var7 = var6.iterator(); var7.hasNext(); par3 += this.fontHeight) {
-            String var8 = (String)var7.next();
-            this.renderStringAligned(var8, par2, par3, par4, this.textColor, par5);
+        for (String line : lines) {
+            this.renderStringAligned(line, x, y, maxWidth, this.textColor, isShadow);
+            y += this.fontHeight;
         }
 
     }
 
-    public int func_27277_a(String par1Str, int par2) {
-        return this.fontHeight * this.listFormattedStringToWidth(par1Str, par2).size();
+    public int getHeightOfConstrainedString(String s, int maxWidth) {
+        return this.fontHeight * this.listFormattedStringToWidth(s, maxWidth).size();
     }
 
     public void setBidiFlag(boolean par1) {
         this.bidiFlag = par1;
     }
 
-    public List listFormattedStringToWidth(String par1Str, int par2) {
-        return Arrays.asList(this.wrapFormattedStringToWidth(par1Str, par2).split("\n"));
+    public List<String> listFormattedStringToWidth(String s, int maxWidth) {
+        return Arrays.asList(this.wrapFormattedStringToWidth(s, maxWidth).split("\n"));
     }
 
-    String wrapFormattedStringToWidth(String par1Str, int par2) {
-        int var3 = this.sizeStringToWidth(par1Str, par2);
-        if(par1Str.length() <= var3) {
-            return par1Str;
+    public String wrapFormattedStringToWidth(String s, int maxWidth) {
+        int var3 = this.sizeStringToWidth(s, maxWidth);
+        if(s.length() <= var3) {
+            return s;
         } else {
-            String var4 = par1Str.substring(0, var3);
-            char var5 = par1Str.charAt(var3);
+            String var4 = s.substring(0, var3);
+            char var5 = s.charAt(var3);
             boolean var6 = var5 == 32 || var5 == 10;
-            String var7 = getFormatFromString(var4) + par1Str.substring(var3 + (var6 ? 1 : 0));
-            return var4 + "\n" + this.wrapFormattedStringToWidth(var7, par2);
+            String var7 = getFormatFromString(var4) + s.substring(var3 + (var6 ? 1 : 0));
+            return var4 + "\n" + this.wrapFormattedStringToWidth(var7, maxWidth);
         }
     }
 
@@ -772,9 +768,9 @@ public class FontRenderer {
             if(var2 < var3 - 1) {
                 char var4 = par0Str.charAt(var2 + 1);
                 if(isFormatColor(var4)) {
-                    var1 = new StringBuilder("\u00a7" + var4);
+                    var1 = new StringBuilder("§" + var4);
                 } else if(isFormatSpecial(var4)) {
-                    var1.append("\u00a7").append(var4);
+                    var1.append("§").append(var4);
                 }
             }
         }
@@ -786,15 +782,14 @@ public class FontRenderer {
         return this.bidiFlag;
     }
 
-    public static String stripColorCodes(String par0Str) {
-        return FORMATTING_CODE_REGEX.matcher(par0Str).replaceAll("");
+    public static String stripColorCodes(String s) {
+        return FORMATTING_CODE_REGEX.matcher(s).replaceAll("");
     }
 
-    public void func_40609_a(String par1Str, int par2, int par3, int par4, int par5, boolean flag) {
+    public void drawStringIntoConstrainedBlock(String s, int x, int y, int maxWidth, int argb, boolean isShadow) {
         this.resetStyles();
-        this.textColor = par5;
-        par1Str = this.trimStringNewline(par1Str);
-        this.renderSplitString(par1Str, par2, par3, par4, flag);
+        this.textColor = argb;
+        this.renderSplitString(trimStringNewline(s), x, y, maxWidth, isShadow);
     }
 
     public void drawCenteredString(String string, int x, int y, int color) {
